'''
Created on Oct 3, 2012

@author: fliwa
'''

import ConfigParser
import os,sys

from monitorupgrade import TLog as TLOG

MUS_CONFIG_FILENAME= 'mus_conf.ini'

class MUSConfigParser(ConfigParser.ConfigParser):
       
    def __init__(self):
        '''
        Constructor
        '''
        #print'MUSConfigParser Constructed'
        TLOG.logger.info('MUSConfigParser Constructed')
        self.config = ConfigParser.SafeConfigParser();
        #super(MUSConfigParser,self).__init__(allow_no_value=True)
        
    def setOptionList(self):
        
        self.options_list = []
        
        for section in self.config.sections():                      
            for option in self.config.options(section):
                self.options_list.append(option)
                
    
    def getOptionList(self):
        return self.options_list
    
    def readConfig(self,config_file_path):
        self.config_file = os.path.abspath(config_file_path)
        if os.path.exists(config_file_path):
            self.config.readfp(DummySecHead(open(self.config_file)))
            
        else:
            print 'No Config file'
            TLOG.logger.info('MUSConfigParser::readConfig()-No Config file ')
            sys.exit()
        self.setOptionList()
        
    def ConfigSectionMap(self,section):
        dict1 = {}
        options = self.config.options(section)
        for option in options:
            try:
                dict1[option] = self.config.get(section, option)
                if dict1[option] == -1:
                    print("skip: %s" % option)
            except:
                print("exception on %s!" % option)
                dict1[option] = None
        return dict1       
    
    def dump(self):
        
        for section in self.config.sections():
            print section
            
            for option in self.config.options(section):
                print " ", option,"=",self.config.get(section,option)
                
 
#For configurations without section heads                    
#http://stackoverflow.com/questions/2819696/parsing-properties-file-in-python/2819788#2819788
class DummySecHead(object):
    def __init__(self, fp):
        self.fp = fp
        self.sechead = '[asection]\n'
    def readline(self):
        if self.sechead:
            try: return self.sechead
            finally: self.sechead = None
        else: return self.fp.readline()